
function boss_load()
  boss = {}
  boss.img = playera
  boss.face = "left"
  boss.width = boss.img:getWidth()
  boss.height = boss.img:getHeight()
  boss.x = screenwidth/2 - boss.width/2
  boss.y = screenheight/2 - boss.height/2
  boss.xvel = 0
  boss.yvel = 0
  boss.friction = 10
  boss.health = 500
  boss.speed = 600
  boss.eat = bossnom1
  boss.hurt = bosshurt1
  boss.intro = bossintro1
  boss.introsaid = false
  boss.die = bossdie1
  boss.diesaid = false
  boss.win = bosswin1
  boss.winsaid = false
  boss.dead = false
  boss.music = bossmusic1
  boss.damage = 4
  boss.shootspeed = 3
  boss.bombdrop = 10
  createNewProgressBar(screenwidth/1.2-70/2,screenheight/20-20,70,20,"bhealth","Boss",small,"game",138,43,226,boss.health,500,0)
end

function boss_Draw()
  if boss.face == "right" then
    love.graphics.draw(boss.img,boss.x,boss.y-boss.height/2,0,1,1)
  elseif boss.face == "left" then
    love.graphics.draw(boss.img,boss.x+boss.width,boss.y-boss.height/2,0,-1,1)
  end
  bossBulletDraw()
  drawBomb()
end

local biTimer = 0
function bossIntroduce(dt)
  biTimer = biTimer + dt
  boss.music:setVolume(0.1)
  boss.music:play()
  boss.intro:play()
  if currentboss == "narwhal" then
    if biTimer >= 7 then
      biTimer = 0
      boss.music:setVolume(0.5)
      boss.introsaid = true
    end
  end
  if currentboss == "donut" then
    if biTimer >= 5.30 then
      biTimer = 0
      boss.music:setVolume(0.5)
      boss.introsaid = true
    end
  end
end

function bossDie(dt)
  boss.dead = true
  biTimer = biTimer + dt
  boss.music:stop()
  boss.die:play()
  boss.y = boss.y + 4
  if currentboss == "narwhal" then
    if biTimer >= 3 then
      biTimer = 0
      boss.diesaid = true
      gamestate = "lose"
    end
  end
  if currentboss == "donut" then
    if biTimer >= 2 then
      biTimer = 0
      boss.diesaid = true
      gamestate = "lose"
    end
  end
end

function bossStatus(dt)
  if not boss.introsaid then
    bossIntroduce(dt)
  end
  if boss.introsaid and not boss.diesaid and not player.dead then
    boss_physics(dt)
  end
  if boss.introsaid and boss.health <= 0 and player.health <= 0 then
    boss.die:stop()
    boo:stop()
    gamestate = "lel"
  end
  if boss.health <= 0 and not boss.diesaid then
    player.health = 100
    bossDie(dt)
  end
  if player.health <= 0 and not boss.diesaid then
     boss.health = 9999
  end
end

function boss_AI(dt)
  bossShoot(dt)
  spawnBombs(dt)
  if math.floor(player.x) + player.width/2 < boss.x + boss.width/2 then
    if boss.xvel > -boss.speed then
      boss.xvel = boss.xvel - boss.speed * dt
      boss.face = "left"
    end
  end
  if math.floor(player.x) + player.width/2 > boss.x + boss.width/2 then
    if boss.xvel < boss.speed then
      boss.xvel = boss.xvel + boss.speed * dt
      boss.face = "right"
    end
  end
  if player.y + player.height/2 < boss.y + boss.height/2 then
    if boss.yvel > -boss.speed then
      boss.yvel = boss.yvel - boss.speed * dt
    end
  end
  if player.y + player.height/2 > boss.y + boss.height/2 then
    if boss.yvel < boss.speed then
      boss.yvel = boss.yvel + boss.speed * dt
    end
  end
end

function boss_physics(dt)
  boss.x = boss.x + boss.xvel * dt
  boss.y = boss.y + boss.yvel * dt
  boss.xvel = boss.xvel * (1-math.min(dt*boss.friction,1))
  boss.yvel = boss.yvel * (1-math.min(dt*boss.friction,1))
  boss_AI(dt)
  if CheckCollision(player.x,player.y,player.width,player.height,boss.x,boss.y-boss.height/2,boss.width,boss.height) then
    player.health = player.health - 0.1
  end
end

bossbullet = {}
bomb = {}
fps = 250

function bombSpawn(x,y)
  width = bombimg:getWidth()
  height = bombimg:getHeight()
  table.insert(bomb,{x=x,y=y,width=width,height=height,timer = 0,exploded = false,calculated = false})
end

function drawBomb()
  for _,v in ipairs(bomb) do
    if not v.exploded then
      if v.timer <= 1.5 then
        love.graphics.setColor(255,255,255,255)
        love.graphics.draw(bombimg,v.x,v.y)
      end
      if v.timer >= 1.5 and v.timer < 2 then
        love.graphics.setColor(153/255,0,0,255)
        love.graphics.draw(bombimg,v.x,v.y)
        love.graphics.setColor(255,255,255,255)
      end
      if v.timer >= 2 and v.timer < 2.3 then
        love.graphics.setColor(255,255,255,255)
        love.graphics.draw(bombimg,v.x,v.y)
      end
      if v.timer >= 2.3 and v.timer < 3 then
        love.graphics.setColor(153/255,0,0,255)
        love.graphics.draw(bombimg,v.x,v.y)
        love.graphics.setColor(255,255,255,255)
      end
      if v.timer >= 3 and v.timer < 3.6 then
        love.graphics.setColor(255,255,255,255)
        love.graphics.draw(bombimg,v.x,v.y)
      end
      if v.timer >= 3.6 and v.timer < 4 then
        love.graphics.setColor(153/255,0,0,255)
        love.graphics.draw(bombimg,v.x,v.y)
        love.graphics.setColor(255,255,255,255)
      end
      if v.timer >= 4 and v.timer < 4.3 then
        love.graphics.setColor(255,255,255,255)
        love.graphics.draw(bombimg,v.x,v.y)
      end
      if v.timer >= 4.3 and v.timer < 4.5 then
        love.graphics.setColor(153/255,0,0,255)
        love.graphics.draw(bombimg,v.x,v.y)
        love.graphics.setColor(255,255,255,255)
      end
      if v.timer >= 4.5 and v.timer < 4.7 then
        love.graphics.setColor(255,255,255,255)
        love.graphics.draw(bombimg,v.x,v.y)
      end
      if v.timer >= 4.7 and v.timer < 4.9 then
        love.graphics.setColor(153/255,0,0,255/255)
        love.graphics.draw(bombimg,v.x,v.y)
        love.graphics.setColor(255,255,255,255)
      end
    end
    if v.exploded then
      for ky,vy in ipairs(Animations) do
        vy:draw(v.x - 64/2, v.y - 64/3)
        if v.timer >= .5 then
          table.remove(bomb,_)
        end
      end
    end
  end
end

function bombExplode(dt)
  for _,v in ipairs(bomb) do
    v.exploded = true
    v.timer = 0
    if math.sqrt((v.x-player.x)^2+(v.y-player.y)^2) <= 64 and not v.calculated then
      v.calculated = true
      player.health = player.health - 25
    end
  end
end

function updateBomb(dt)
  for _,v in ipairs(bomb) do
    if v.y < screenheight-player.height then
      v.y = v.y + 2 + dt
    end
    v.timer = v.timer + dt
    if v.timer >= 5 then
      Animations[1]:stop()
      Animations[1]:play()
      boom:stop()
      boom:play()
      bombExplode(dt)
    end
  end
end

function removeInstances()
  for _,v in ipairs(bomb) do
    table.remove(bomb,_)
  end
end

bombTimer = 0
function spawnBombs(dt)
  updateBomb(dt)
  bombTimer = bombTimer + dt
  if bombTimer >= boss.bombdrop then
    bombTimer = 0
    bombSpawn(boss.x,boss.y)
  end
end


function bossBulletShoot(x,y)
  lazer:stop()
  lazer:play()
  bossbullet.img = ytaco
  width = bossbullet.img:getWidth()
  height = bossbullet.img:getHeight()
  angle2 = 0
  local startX = boss.x + boss.width/2
  local startY = boss.y + boss.height/2
  local playerX = player.x
  local playerY = player.y
  local angle = math.atan2(playerY - startY,(playerX - startX))
  local bulletDx = fps* math.cos(angle)
  local bulletDy = fps* math.sin(angle)
  dx = bulletDx
  dy = bulletDy
  table.insert(bossbullet,{width = width,height=height,angle = angle,angle2=angle2,x = startX, y = startY, id = #bossbullet + 1, dx=dx,dy=dy})
end

function bossBulletDraw()
  for _,v in ipairs(bossbullet) do
    createNewLight(v.x,v.y,math.random(1,255)/255,math.random(1,255)/255,math.random(1,255)/255,100)
    love.graphics.draw(bossbullet.img,v.x,v.y,v.angle2,1,1,taco:getWidth()/2,taco:getHeight()/2)
  end
end

function bossBulletCollide()
  for _,v in ipairs(bossbullet) do
     if v.y >= screenheight then
      table.remove(bossbullet,_)
    end
    if v.y <= 0 then
      table.remove(bossbullet,_)
    end
    if v.x >= screenwidth then
      table.remove(bossbullet,_)
    end
    if v.x <= 0 then
      table.remove(bossbullet,_)
    end
    if v.x > player.x and
      v.x < player.x + player.width and
      v.y > player.y and
      v.y < player.y + player.height and bossbattle then
      player.health = player.health - boss.damage
      table.remove(bossbullet,_)
    end
    if CheckCollision(v.x,v.y,v.width,v.height,player.x,player.y,player.width,player.height) then
      player.health = player.health - boss.damage
      table.remove(bossbullet,_)
    end
  end
end

function bossBulletUpdate(dt)
  for _,v in ipairs(bossbullet) do
    bossBulletCollide()
    v.x = v.x + (v.dx * dt)
    v.y = v.y + (v.dy * dt)
    v.angle2 = v.angle2 + math.pi * dt
  end
end

local bTimer = 0
function bossShoot(dt)
  bossBulletUpdate(dt)
  bTimer = bTimer + dt
  if bTimer >= boss.shootspeed then
    bossBulletShoot(x,y)
    bTimer = 0
  end
end
