
cloud = {}

function newCloud(x,y,speed,dir)
  table.insert(cloud,{x=x,y=y,speed=speed,dir=dir})
end

function drawClouds()
  for _,v in ipairs(cloud) do
    clouds:setFilter("nearest","nearest")
    love.graphics.draw(clouds,v.x,v.y,0,2,2)
  end
end

function updateClouds(dt)
  for _,v in ipairs(cloud) do
    if v.dir == "left" then
      v.x = v.x + v.speed + 0.01
      v.y = v.y
      if v.x - clouds:getWidth() > screenwidth then
        table.remove(cloud,_)
      end
    elseif v.dir == "right" then
      v.x = v.x - v.speed - 0.01
      v.y = v.y
      if v.x + clouds:getWidth()+ clouds:getWidth() <= 0 then
        table.remove(cloud,_)
      end
    end
  end
end

local Timer = 0
local rSpawn = math.random(screenheight/9,screenheight/1.7)
local Speed = math.random(1.5,2)
local limit = 0
local rDir = math.random(1,2)

function cloudSpawner(dt)
  updateClouds(dt)
  Timer = Timer + dt
  if Timer >= limit then
    if rDir == 1 then
      newCloud(0-clouds:getWidth()-clouds:getWidth(),rSpawn,Speed,"left")
      rSpawn = math.random(screenheight/9,screenheight/1.7)
      limit = math.random(1,2)
      rDir = math.random(1,2)
      Timer = 0
    elseif rDir == 2 then
      newCloud(screenwidth+clouds:getWidth(),rSpawn,Speed,"right")
      rSpawn = math.random(screenheight/9,screenheight/1.7)
      limit = math.random(1,2)
      rDir = math.random(1,2)
      Timer = 0
    end
  end
end
