
player = {}

function player_load()
  player.speed = 200
  player.jspeed = 0
  player.friction = 3
  player.xvel = 0
  player.yvel = 0
  player.angle = 0
  player.grav = 1.5
  player.health = 100
  player.jumped = false
  player.dead = false
  player.hat = 0
  player.hatv = 0
  player.hatangle = 0
  player.mhat = 0
  player.img = playera
  player.width = player.img:getWidth()
  player.height = player.img:getHeight()
  player.x = screenwidth/2-player.width/2
  player.y = screenheight/2-player.height/2
  player.damage = 3
  player.multiplier = 0
end

function player_draw()
  love.graphics.draw(player.img,player.x,player.y,player.angle,1,1,player.width/2,player.height/2)
  setPlayerHat()
end

function player_physics(dt)
  local frame = dt * 30
  player.jspeed = player.jspeed + player.grav * frame
  player.y = player.y + player.jspeed * frame
  if player.y > screenheight-player.height then
    player.y = player.y - player.jspeed * frame
    player.jspeed = 0
    player.jumped = false
  end
  player.x = player.x + player.xvel * dt
  player.xvel = player.xvel*(1-math.min(dt*player.friction,1))
  if player.x - player.width/2 <= 0 then
    player.x = 0 + player.width/2
  end
  if player.x + player.width/2 >= screenwidth then
    player.x = screenwidth - player.width/2
  end
end

function player_jump(key)
  if key == "space" and player.y < screenheight-player.height and not player.jumped and not player.dead then
    player.jumped = true
    player.angle = 0
    player.jspeed = -20
  end
end

function player_controls(dt)
  if love.keyboard.isDown("a") or love.keyboard.isDown("left")and not player.dead then
    player.xvel  = player.xvel - player.speed * dt
		player.x = player.x - player.speed * dt
  end
  if love.keyboard.isDown("d") or love.keyboard.isDown("right") and not player.dead then
    player.xvel  = player.xvel + player.speed * dt
		player.x = player.x + player.speed * dt
  end
end