
Taco = {}

function tacoSpawn(x,y,ttype)
  angle = 0
  table.insert(Taco,{x=x,y=y,angle=angle,id=#Taco+1,ttype=ttype,collided = false,timer = 0})
end

function tacoDraw()
  for _,v in ipairs(Taco) do
    for ky,vy in ipairs(Animations) do
      if v.collided then
        v.timer = v.timer + 0.01
        vy:draw(v.x - 64/2, v.y - 64/3)
        if v.timer >= .5 then
          table.remove(Taco,_)
        end
      end
    end
    if v.ttype == "normal" then
      taco:setFilter("nearest","nearest")
      love.graphics.draw(taco,v.x,v.y,v.angle,1,1,taco:getWidth()/2,taco:getHeight()/2)
    elseif v.ttype == "mega" then
      mtaco:setFilter("nearest","nearest")
      createNewLight(v.x,v.y,math.random(1,255)/255,math.random(1,255)/255,math.random(1,255)/255,100/255)
      love.graphics.draw(mtaco,v.x,v.y,v.angle,1,1,mtaco:getWidth()/2,mtaco:getHeight()/2)
    elseif v.ttype == "yucky" and not v.collided then
      ytaco:setFilter("nearest","nearest")
      love.graphics.draw(ytaco,v.x, v.y,v.angle,1,1,mtaco:getWidth(), mtaco:getHeight())
    end
  end
end

function tacoCollide(dt)
  for _,v in ipairs(Taco) do
    if gamestate ~= "game" and gamestate ~= "game2" then
      if v.y >= screenheight then
        table.remove(Taco,_)
      end
    elseif gamestate == "game" then
      if v.y - mtaco:getHeight() >= screenheight then
        table.remove(Taco,_)
      end
      if CheckCollision(v.x,v.y,taco:getWidth(),taco:getHeight(),player.x,player.y,player.width,player.height) and v.ttype == "normal" then
        eat:stop()
        eat:play()
        tc = tc + 1
        g.points = g.points + 1
        player.health = player.health + 1
        table.remove(Taco,_)
      end
      if CheckCollision(v.x,v.y,ytaco:getWidth(),ytaco:getHeight(),player.x,player.y,player.width,player.height) and v.ttype == "yucky" and not v.collided then
        eat:stop()
        eat:play()
        tc = tc - 1
        if g.points > 0 then
          g.points = g.points - 1
        end
        player.health = player.health - 10
        table.remove(Taco,_)
      end
      if CheckCollision(v.x,v.y,mtaco:getWidth(),mtaco:getHeight(),player.x,player.y,player.width,player.height) and v.ttype == "mega" then
        eat:stop()
        eat:play()
        tc = tc + 49 + fc
        g.points = g.points + 10
        player.health = player.health + 10
        table.remove(Taco,_)
      end
      if CheckCollision(v.x,v.y,ytaco:getWidth(),ytaco:getHeight(),boss.x,boss.y-boss.height/2,boss.width,boss.height) and v.ttype == "yucky" and bossDetermined and not boss.dead and not v.collided then
        boss.eat:stop()
        boss.eat:play()
        boss.health = boss.health + 10
        table.remove(Taco,_)
      end
    elseif gamestate == "game2" then
      if v.y - mtaco:getHeight() >= screenheight then
        table.remove(Taco,_)
      end
      if CheckCollision(v.x,v.y,taco:getWidth(),taco:getHeight(),player.x,player.y,player.width,player.height) and v.ttype == "normal" then
        eat:stop()
        eat:play()
        g.points = g.points + 1
        player.health = player.health + 1
        table.remove(Taco,_)
      end
      if CheckCollision(v.x,v.y,ytaco:getWidth(),ytaco:getHeight(),player.x,player.y,player.width,player.height) and v.ttype == "yucky" and not v.collided then
        eat:stop()
        eat:play()
        if g.points > 10 then
          g.points = g.points - 10
        end
        player.health = player.health - 25
        table.remove(Taco,_)
      end
      if CheckCollision(v.x,v.y,mtaco:getWidth(),mtaco:getHeight(),player.x,player.y,player.width,player.height) and v.ttype == "mega" then
        eat:stop()
        eat:play()
        g.points = g.points + 5
        player.health = player.health + 10
        table.remove(Taco,_)
      end
    end
  end
end

function tacoUpdate(dt)
  for _,v in ipairs(Taco) do
     if v.ttype == "normal" then
      v.x = v.x
      v.y = v.y + 4 + dt + tspeed
      v.angle = v.angle + math.pi * dt
    elseif v.ttype == "mega" then
      v.x = v.x
      v.y = v.y + 6 + dt + tspeed
      v.angle = v.angle + math.pi * dt
    elseif v.ttype == "yucky" and not v.collided then
      v.x = v.x
      v.y = v.y + 5 + dt + tspeed
      v.angle = v.angle + math.pi * dt
    elseif v.ttype == "yucky" and v.collided then
      v.x = v.x
      v.y = v.y + 1
    end
  end
end

local Timer = 0
local tProb = math.random(1,100)
function tacoRain(dt)
  if gamestate ~= "game" and gamestate ~= "game2" then
    tacoUpdate(dt)
    tacoCollide(dt)
    Timer = Timer + dt
    if Timer >= .1 then
      if tProb == 1 then
        tProb = math.random(1,100)
        tacoSpawn(math.random(screenwidth/13,screenwidth/1.1),0-mtaco:getHeight(),"mega")
        Timer = 0
      elseif tProb > 1 then
        tProb = math.random(1,100)
        tacoSpawn(math.random(screenwidth/10,screenwidth/1.1),0-taco:getHeight(),"normal")
        Timer = 0
      end
    end
  elseif gamestate == "game" or gamestate == "game2" then
    tacoUpdate(dt)
    tacoCollide(dt)
    Timer = Timer + dt
    if Timer >= gspeed / fc then
      if tProb == 1 then
        tProb = math.random(1,30)
        tacoSpawn(math.random(screenwidth/13,screenwidth/1.1),0-mtaco:getHeight(),"mega")
        Timer = 0
      elseif tProb >= 2 and tProb <= 5 then
        tProb = math.random(1,30)
        tacoSpawn(math.random(screenwidth/13,screenwidth/1.1),0-ytaco:getHeight(),"yucky")
        Timer = 0
      elseif tProb >= 6 then
        tProb = math.random(1,30)
        tacoSpawn(math.random(screenwidth/13,screenwidth/1.1),0-taco:getHeight(),"normal")
        Timer = 0
      end
    end
  end
end
