--[[
Xision Intro
Used for the creation of Xision's Intro
Created by Bruce Berrios
]]--

IntroScreen = {}

local lx = screenwidth/2
local ly = 0--screenheight/2
local la = 255

function wait(seconds)
  while seconds > 0 do
    seconds = seconds - coroutine.yield(true)
  end
end

function IntroScreen:start()
  self.objects = {}
  self.co = coroutine.wrap(function()
	wait(.2)
      ly = 0--screenheight/2 - screenheight/2
      la = 0
      self.objects[1] = logo
      imusic:play()
      repeat
        wait(love.timer.getDelta())
        ly = ly + 10
        la = la + 3.5
      until ly >= screenheight/2 - logo:getHeight()/2 and la >= 255
      la = 255
      --ly = screenheight/2 - logo:getHeight()/2
      wait(1.2)
      repeat
        wait(0.01)
        ly = ly + 20
        la = la - 20
        swoosh:play()
      until ly >= screenheight + self.objects[1]:getHeight()/2
        wait(.5)
      self.objects[1] = nil
      gamestate = "menu"
      music:play()
  end)
end

function IntroScreen:update(dt)
  self.co(dt)
end

function IntroScreen:draw()
  for i = 1,#self.objects do
    love.graphics.setBackgroundColor(255,255,255)
	love.graphics.setColor(255,255,255,la)
    self.objects[i]:setFilter("nearest","nearest")
    love.graphics.draw(self.objects[i],lx - self.objects[i]:getWidth()/2,ly - self.objects[i]:getHeight()/2)
	love.graphics.setColor(255,255,255,255)
  end
end
