
-- Created by Bruce Berrios

math.randomseed(os.time());math.random();math.random() -- To generate some nice random numbers :D

gamestate = "intro"
build = "Alpha"
vers = "0.74"
mdir = "Resources/"
fdir = mdir.."Files/"
fdir2 = mdir.."Fonts/"
idir = mdir.."Images/"
sdir = mdir.."Sounds/"
sdir2 = mdir.."Shaders/"
xdir = mdir.."XisionLibrary/"

local files = love.filesystem.getDirectoryItems(fdir)
screenwidth = love.graphics.getWidth()
screenheight = love.graphics.getHeight()
mousex = love.mouse.getX()
mousey = love.mouse.getY()

function love.load(arg)
  print("Initializing Loadout...")
  Slib = require(fdir.."slib")
  SpriteSheet = require(fdir.."Animations")
  require(fdir.."Addons")
  require(fdir.."Boss")
  require(fdir.."Camera")
  require(fdir.."Cloud")
  require(fdir.."DataPersistance")
  require(fdir.."Game")
  require(fdir.."Hats")
  require(fdir.."InfiniteRun")
  require(fdir.."InitShaders")
  require(fdir.."Intro")
  require(fdir.."Lel")
  require(fdir.."LevelSelect")
  require(fdir.."LoadGame")
  require(fdir.."LoadScreen")
  require(fdir.."Lose")
  require(fdir.."Menu")
  require(fdir.."Options")
  require(fdir.."Player")
  require(fdir.."PlayerWeapon")
  require(fdir.."Shop")
  require(fdir.."Stats")
  require(fdir.."Tacos")
  calculateScale()
  checkSave()
  loadGame()
  print("Loading Xision Library")
  require(xdir.."Init")
  initXlib()
  gif1 = "Resources/GIFS/LightSpeed/"
  gif2 = "Resources/GIFS/Tunnel/"
  GS:Init("GSLIB")
  light = GS.NewGif(gif1, true)
  tunnel = GS.NewGif(gif2, true)
  load_shaders()
  menu_load()
  select_load()
  shop_load()
  opt_load()
  player_load()
  boss_load()
  game_load()
  inf_load()
  lose_load()
  print("Finalizing loadout...")
  intro_start()
end

local timer = 0
function love.update(dt)
	timer = timer + dt
  for k,v in ipairs(Animations) do v:update(dt) end
  shader_update(dt)
  buttonMouse()
  textboxType(dt)
  mousex = love.mouse.getX()
  mousey = love.mouse.getY()
  --print("X: "..mousex.." Y :"..mousey)
  if gamestate == "intro" then
    intro_update(dt)
  elseif gamestate == "menu" then
    menu_update(dt)
  elseif gamestate == "select" then
    select_update(dt)
  elseif gamestate == "shop" then
    shop_update(dt)
  elseif gamestate == "options" then
    opt_update(dt)
  elseif gamestate == "game" then
    game_update(dt)
    bulletUpdate(dt)
  if love.mouse.isDown(1) and timer >= .2 and tc > 0  and not player.dead and not quitclicked then
		shot:stop()
		shot:play()
		timer = 0
		bulletShoot(mousex,mousey)
	end
  elseif gamestate == "game2" then
    inf_update(dt)
	if love.mouse.isDown(1) and timer >= .2 and tc > 0  and not player.dead and not quitclicked then
		shot:stop()
		shot:play()
		timer = 0
		bulletShoot(mousex,mousey)
	end
  elseif gamestate == "loading" then
    loadG(dt,.3,"placebo")
  elseif gamestate == "lel" then
    lel_update(dt)
  elseif gamestate == "lose" then
    lose_update(dt)
  end
  stats_update(dt)
  updateProgress()
  updateScroll()
  clickScroll()
end

function love.keypressed(key)
  if key == "escape" then
    love.quit()
  end
  if key == "f12" then
    if not toggle then
      toggle = true
      elseif toggle then
      toggle = false
    end
  end
  if gamestate == "game" or gamestate == "game2" then
    game_key(key)
  end
end
function love.draw()
  if gamestate == "intro" then
    intro_draw()
  elseif gamestate == "menu" then
    menu_draw()
  elseif gamestate == "select" then
    select_draw()
  elseif gamestate == "shop" then
    shop_draw()
  elseif gamestate == "options" then
    opt_draw()
  elseif gamestate == "loading" then
    loadDraw()
  elseif gamestate == "game" then
    game_draw()
    bulletDraw()
  elseif gamestate == "game2" then
    inf_draw()
  elseif gamestate == "lel" then
    lel_draw()
  elseif gamestate == "lose" then
    lose_draw()
  end
  clipScroll()
  drawScrollFrame()
  drawButtons()
  drawProgress()
  stats_draw()
  drawTextbox()
end

function love.mousepressed(x,y,button)
  if button == 1 then
    buttonClicked(x,y)
    textboxFocus(x,y)
    mouseScroll(x,y,1)
    if gamestate == "shop" then
      shopButtons(x,y)
    end
  end
end

function love.wheelmoved(x, y)
  if(gamestate == "shop") then
    if y > 0 then
        mouseScroll(x,y,"wu")
      elseif y < 0 then
        mouseScroll(x,y,"wd")
      end
  end
end

function love.quit()
  save(g)
  love.event.quit()
end
